## ghostscript 9.55.0~dfsg1

=== leptonica/prog/CMakeLists.txt ===
########################################
# FUNCTION add_prog_target
########################################
function(add_prog_target target)
    set                             (${target}_src "${ARGN}")
    if (WIN32)
        set_source_files_properties (${${target}_src} PROPERTIES LANGUAGE CXX)
    endif()
    add_executable                  (${target} ${${target}_src})
    if (BUILD_SHARED_LIBS)
        target_compile_definitions  (${target} PRIVATE -DLIBLEPT_IMPORTS)
    endif()
    target_link_libraries           (${target} leptonica)
    set_target_properties           (${target} PROPERTIES FOLDER prog)
endfunction(add_prog_target)
########################################

add_prog_target(adaptmap_reg adaptmap_reg.c)
add_prog_target(adaptnorm_reg adaptnorm_reg.c)
add_prog_target(affine_reg affine_reg.c)
add_prog_target(alltests_reg alltests_reg.c)
add_prog_target(alphaops_reg alphaops_reg.c)
add_prog_target(alphaxform_reg alphaxform_reg.c)
add_prog_target(baseline_reg baseline_reg.c)
add_prog_target(bilateral1_reg bilateral1_reg.c)
add_prog_target(bilateral2_reg bilateral2_reg.c)
add_prog_target(bilinear_reg bilinear_reg.c)
add_prog_target(binarize_reg binarize_reg.c)
add_prog_target(binmorph1_reg binmorph1_reg.c)
add_prog_target(binmorph2_reg binmorph2_reg.c)
add_prog_target(binmorph3_reg binmorph3_reg.c)
add_prog_target(binmorph4_reg binmorph4_reg.c)
add_prog_target(binmorph5_reg binmorph5_reg.c)
add_prog_target(binmorph6_reg binmorph6_reg.c)
add_prog_target(blackwhite_reg blackwhite_reg.c)
add_prog_target(blend1_reg blend1_reg.c)
add_prog_target(blend2_reg blend2_reg.c)
add_prog_target(blend3_reg blend3_reg.c)
add_prog_target(blend4_reg blend4_reg.c)
add_prog_target(blend5_reg blend5_reg.c)
add_prog_target(boxa1_reg boxa1_reg.c)
add_prog_target(boxa2_reg boxa2_reg.c)
add_prog_target(boxa3_reg boxa3_reg.c)
add_prog_target(boxa4_reg boxa4_reg.c)
add_prog_target(bytea_reg bytea_reg.c)
add_prog_target(ccbord_reg ccbord_reg.c)
add_prog_target(ccthin1_reg ccthin1_reg.c)
add_prog_target(ccthin2_reg ccthin2_reg.c)
add_prog_target(checkerboard_reg checkerboard_reg.c)
add_prog_target(circle_reg circle_reg.c)
add_prog_target(cmapquant_reg cmapquant_reg.c)
add_prog_target(colorcontent_reg colorcontent_reg.c)
add_prog_target(colorfill_reg colorfill_reg.c)
add_prog_target(coloring_reg coloring_reg.c)
add_prog_target(colorize_reg colorize_reg.c)
add_prog_target(colormask_reg colormask_reg.c)
add_prog_target(colormorph_reg colormorph_reg.c)
add_prog_target(colorquant_reg colorquant_reg.c)
add_prog_target(colorseg_reg colorseg_reg.c)
add_prog_target(colorspace_reg colorspace_reg.c)
add_prog_target(compare_reg compare_reg.c)
add_prog_target(compfilter_reg compfilter_reg.c)
add_prog_target(conncomp_reg conncomp_reg.c)
add_prog_target(conversion_reg conversion_reg.c)
add_prog_target(convolve_reg convolve_reg.c)
add_prog_target(crop_reg crop_reg.c)
add_prog_target(dewarp_reg dewarp_reg.c)
add_prog_target(distance_reg distance_reg.c)
add_prog_target(dither_reg dither_reg.c)
add_prog_target(dna_reg dna_reg.c)
add_prog_target(dwamorph1_reg dwamorph1_reg.c dwalinear.3.c dwalinearlow.3.c)
add_prog_target(dwamorph2_reg dwamorph2_reg.c dwalinear.3.c dwalinearlow.3.c)
add_prog_target(edge_reg edge_reg.c)
add_prog_target(encoding_reg encoding_reg.c)
add_prog_target(enhance_reg enhance_reg.c)
add_prog_target(equal_reg equal_reg.c)
add_prog_target(expand_reg expand_reg.c)
add_prog_target(extrema_reg extrema_reg.c)
add_prog_target(falsecolor_reg falsecolor_reg.c)
add_prog_target(fhmtauto_reg fhmtauto_reg.c)
add_prog_target(files_reg files_reg.c)
add_prog_target(findcorners_reg findcorners_reg.c)
add_prog_target(findpattern_reg findpattern_reg.c)
add_prog_target(flipdetect_reg flipdetect_reg.c)
add_prog_target(fmorphauto_reg fmorphauto_reg.c)
add_prog_target(fpix1_reg fpix1_reg.c)
add_prog_target(fpix2_reg fpix2_reg.c)
add_prog_target(genfonts_reg genfonts_reg.c)
add_prog_target(gifio_reg gifio_reg.c)
add_prog_target(grayfill_reg grayfill_reg.c)
add_prog_target(graymorph1_reg graymorph1_reg.c)
add_prog_target(graymorph2_reg graymorph2_reg.c)
add_prog_target(grayquant_reg grayquant_reg.c)
add_prog_target(hardlight_reg hardlight_reg.c)
add_prog_target(hash_reg hash_reg.c)
add_prog_target(heap_reg heap_reg.c)
add_prog_target(insert_reg insert_reg.c)
add_prog_target(ioformats_reg ioformats_reg.c)
add_prog_target(iomisc_reg iomisc_reg.c)
add_prog_target(italic_reg italic_reg.c)
add_prog_target(jbclass_reg jbclass_reg.c)
add_prog_target(jp2kio_reg jp2kio_reg.c)
add_prog_target(jpegio_reg jpegio_reg.c)
add_prog_target(kernel_reg kernel_reg.c)
add_prog_target(label_reg label_reg.c)
add_prog_target(lineremoval_reg lineremoval_reg.c)
add_prog_target(locminmax_reg locminmax_reg.c)
add_prog_target(logicops_reg logicops_reg.c)
add_prog_target(lowaccess_reg lowaccess_reg.c)
add_prog_target(lowsat_reg lowsat_reg.c)
add_prog_target(maze_reg maze_reg.c)
add_prog_target(mtiff_reg mtiff_reg.c)
add_prog_target(multitype_reg multitype_reg.c)
add_prog_target(nearline_reg nearline_reg.c)
add_prog_target(newspaper_reg newspaper_reg.c)
add_prog_target(numa1_reg numa1_reg.c)
add_prog_target(numa2_reg numa2_reg.c)
add_prog_target(numa3_reg numa3_reg.c)
add_prog_target(overlap_reg overlap_reg.c)
add_prog_target(pageseg_reg pageseg_reg.c)
add_prog_target(paintmask_reg paintmask_reg.c)
add_prog_target(paint_reg paint_reg.c)
add_prog_target(pdfio1_reg pdfio1_reg.c)
add_prog_target(pdfio2_reg pdfio2_reg.c)
add_prog_target(pdfseg_reg pdfseg_reg.c)
add_prog_target(pixa1_reg pixa1_reg.c)
add_prog_target(pixa2_reg pixa2_reg.c)
add_prog_target(pixadisp_reg pixadisp_reg.c)
add_prog_target(pixalloc_reg pixalloc_reg.c)
add_prog_target(pixcomp_reg pixcomp_reg.c)
add_prog_target(pixmem_reg pixmem_reg.c)
add_prog_target(pixserial_reg pixserial_reg.c)
add_prog_target(pixtile_reg pixtile_reg.c)
add_prog_target(pngio_reg pngio_reg.c)
add_prog_target(pnmio_reg pnmio_reg.c)
add_prog_target(projection_reg projection_reg.c)
add_prog_target(projective_reg projective_reg.c)
add_prog_target(psioseg_reg psioseg_reg.c)
add_prog_target(psio_reg psio_reg.c)
add_prog_target(pta_reg pta_reg.c)
add_prog_target(ptra1_reg ptra1_reg.c)
add_prog_target(ptra2_reg ptra2_reg.c)
add_prog_target(quadtree_reg quadtree_reg.c)
add_prog_target(rankbin_reg rankbin_reg.c)
add_prog_target(rankhisto_reg rankhisto_reg.c)
add_prog_target(rank_reg rank_reg.c)
add_prog_target(rasteropip_reg rasteropip_reg.c)
add_prog_target(rasterop_reg rasterop_reg.c)
add_prog_target(rectangle_reg rectangle_reg.c)
add_prog_target(rotate1_reg rotate1_reg.c)
add_prog_target(rotate2_reg rotate2_reg.c)
add_prog_target(scale_reg scale_reg.c)
add_prog_target(selio_reg selio_reg.c)
add_prog_target(shear1_reg shear1_reg.c)
add_prog_target(shear2_reg shear2_reg.c)
add_prog_target(skew_reg skew_reg.c)
add_prog_target(smallpix_reg smallpix_reg.c)
add_prog_target(smoothedge_reg smoothedge_reg.c)
add_prog_target(speckle_reg speckle_reg.c)
add_prog_target(splitcomp_reg splitcomp_reg.c)
add_prog_target(string_reg string_reg.c)
add_prog_target(subpixel_reg subpixel_reg.c)
add_prog_target(texturefill_reg texturefill_reg.c)
add_prog_target(threshnorm_reg threshnorm_reg.c)
add_prog_target(translate_reg translate_reg.c)
add_prog_target(warper_reg warper_reg.c)
add_prog_target(watershed_reg watershed_reg.c)
add_prog_target(webpio_reg webpio_reg.c)
add_prog_target(webpanimio_reg webpanimio_reg.c)
add_prog_target(wordboxes_reg wordboxes_reg.c)
add_prog_target(writetext_reg writetext_reg.c)
add_prog_target(xformbox_reg xformbox_reg.c)
add_prog_target(adaptmap_dark adaptmap_dark.c)
add_prog_target(arabic_lines arabic_lines.c)
add_prog_target(arithtest arithtest.c)
add_prog_target(autogentest1 autogentest1.c)
add_prog_target(autogentest2 autogentest2.c autogen.137.c)
add_prog_target(barcodetest barcodetest.c)
add_prog_target(binarize_set binarize_set.c)
add_prog_target(binarizefiles binarizefiles.c)
add_prog_target(bincompare bincompare.c)
add_prog_target(blendcmaptest blendcmaptest.c)
add_prog_target(buffertest buffertest.c)
add_prog_target(ccbordtest ccbordtest.c)
add_prog_target(cctest1 cctest1.c)
add_prog_target(cleanpdf cleanpdf.c)
add_prog_target(colorsegtest colorsegtest.c)
add_prog_target(comparepages comparepages.c)
add_prog_target(comparepixa comparepixa.c)
add_prog_target(comparetest comparetest.c)
add_prog_target(concatpdf concatpdf.c)
add_prog_target(contrasttest contrasttest.c)
add_prog_target(convertfilestopdf convertfilestopdf.c)
add_prog_target(convertfilestops convertfilestops.c)
add_prog_target(convertformat convertformat.c)
add_prog_target(convertsegfilestopdf convertsegfilestopdf.c)
add_prog_target(convertsegfilestops convertsegfilestops.c)
add_prog_target(converttogray converttogray.c)
add_prog_target(converttopdf converttopdf.c)
add_prog_target(converttops converttops.c)
add_prog_target(cornertest cornertest.c)
add_prog_target(corrupttest corrupttest.c)
add_prog_target(croptext croptext.c)
add_prog_target(deskew_it deskew_it.c)
add_prog_target(dewarprules dewarprules.c)
add_prog_target(dewarptest1 dewarptest1.c)
add_prog_target(dewarptest2 dewarptest2.c)
add_prog_target(dewarptest3 dewarptest3.c)
add_prog_target(dewarptest4 dewarptest4.c)
add_prog_target(dewarptest5 dewarptest5.c)
add_prog_target(digitprep1 digitprep1.c)
add_prog_target(displayboxa displayboxa.c)
add_prog_target(displayboxes_on_pixa displayboxes_on_pixa.c)
add_prog_target(displaypix displaypix.c)
add_prog_target(displaypixa displaypixa.c)
add_prog_target(dwalineargen dwalineargen.c)
add_prog_target(fcombautogen fcombautogen.c)
add_prog_target(fhmtautogen fhmtautogen.c)
add_prog_target(fileinfo fileinfo.c)
add_prog_target(findbinding findbinding.c)
add_prog_target(find_colorregions find_colorregions.c)
add_prog_target(findpattern1 findpattern1.c)
add_prog_target(findpattern2 findpattern2.c)
add_prog_target(findpattern3 findpattern3.c)
add_prog_target(fmorphautogen fmorphautogen.c)
add_prog_target(fpixcontours fpixcontours.c)
add_prog_target(gammatest gammatest.c)
add_prog_target(graphicstest graphicstest.c)
add_prog_target(graymorphtest graymorphtest.c)
add_prog_target(histotest histotest.c)
add_prog_target(histoduptest histoduptest.c)
add_prog_target(htmlviewer htmlviewer.c)
add_prog_target(imagetops imagetops.c)
add_prog_target(jbcorrelation jbcorrelation.c)
add_prog_target(jbrankhaus jbrankhaus.c)
add_prog_target(jbwords jbwords.c)
add_prog_target(lightcolortest lightcolortest.c)
add_prog_target(listtest listtest.c)
add_prog_target(livre_adapt livre_adapt.c)
add_prog_target(livre_hmt livre_hmt.c)
add_prog_target(livre_makefigs livre_makefigs.c)
add_prog_target(livre_orient livre_orient.c)
add_prog_target(livre_pageseg livre_pageseg.c)
add_prog_target(livre_seedgen livre_seedgen.c)
add_prog_target(livre_tophat livre_tophat.c)
add_prog_target(maketile maketile.c)
add_prog_target(maptest maptest.c)
add_prog_target(messagetest messagetest.c)
add_prog_target(misctest1 misctest1.c)
add_prog_target(modifyhuesat modifyhuesat.c)
add_prog_target(morphseq_reg morphseq_reg.c)
add_prog_target(morphtest1 morphtest1.c)
add_prog_target(numaranktest numaranktest.c)
add_prog_target(otsutest1 otsutest1.c)
add_prog_target(otsutest2 otsutest2.c)
add_prog_target(pagesegtest1 pagesegtest1.c)
add_prog_target(pagesegtest2 pagesegtest2.c)
add_prog_target(partifytest partifytest.c)
add_prog_target(partitiontest partitiontest.c)
add_prog_target(percolatetest percolatetest.c)
add_prog_target(pixaatest pixaatest.c)
add_prog_target(pixafileinfo pixafileinfo.c)
add_prog_target(plottest plottest.c)
add_prog_target(printimage printimage.c)
add_prog_target(printsplitimage printsplitimage.c)
add_prog_target(printtiff printtiff.c)
add_prog_target(rasteroptest rasteroptest.c)
add_prog_target(rbtreetest rbtreetest.c)
add_prog_target(recog_bootnum1 recog_bootnum1.c)
add_prog_target(recog_bootnum2 recog_bootnum2.c)
add_prog_target(recog_bootnum3 recog_bootnum3.c)
add_prog_target(recogsort recogsort.c)
add_prog_target(recogtest1 recogtest1.c)

=== tesseract/src/training/CMakeLists.txt ===
#
# tesseract
#

if (UNIX AND NOT ANDROID)
    set(LIB_pthread pthread)
endif()

if (SW_BUILD)
    set(ICU_FOUND 1)
endif()

# experimental
if (MSVC AND NOT SW_BUILD AND NOT USE_SYSTEM_ICU)
    include(CheckTypeSize)
    check_type_size("void *" SIZEOF_VOID_P)

    if (SIZEOF_VOID_P EQUAL 8)
        set(X64 1)
        set(ARCH_DIR_NAME 64)
    elseif (SIZEOF_VOID_P EQUAL 4)
        set(X86 1)
        set(ARCH_DIR_NAME 32)
    else()
        message(FATAL_ERROR "Cannot determine target architecture")
    endif()

    set(icu_dir "${CMAKE_CURRENT_BINARY_DIR}/icu")
    set(icu_archive "${icu_dir}/icu${ARCH_DIR_NAME}.zip")

    if (X86)
        set(icu_hash 45167a240b60e36b59a87eda23490ce4)
    else()
        set(icu_hash 480c72491576c048de1218c3c5519399)
    endif()

    message(STATUS "Downloading latest ICU binaries")

    file(DOWNLOAD
        "https://github.com/unicode-org/icu/releases/download/release-56-1/icu4c-56_1-Win${ARCH_DIR_NAME}-msvc10.zip"
        "${icu_archive}"
        SHOW_PROGRESS
        INACTIVITY_TIMEOUT 300 # seconds
        EXPECTED_HASH MD5=${icu_hash}
    )
    execute_process(COMMAND ${CMAKE_COMMAND} -E tar xz "${icu_archive}"
        WORKING_DIRECTORY "${icu_dir}"
        RESULT_VARIABLE __result
    )
    if(NOT __result EQUAL 0)
        message(FATAL_ERROR "error ${__result}")
    endif()

    set(ICU_ROOT ${icu_dir}/icu)
endif()
# experimental

if (NOT SW_BUILD)
    if (PKG_CONFIG_FOUND)
        pkg_check_modules(ICU REQUIRED icu-uc icu-i18n)
    else()
        find_package(ICU 52.1 COMPONENTS uc i18n)
    endif()
endif()


########################################
# LIBRARY common_training
########################################

set(common_training_src
    common/commandlineflags.cpp
    common/commandlineflags.h
    common/commontraining.cpp
    common/commontraining.h
    common/ctc.cpp
    common/ctc.h
    common/networkbuilder.cpp
    common/networkbuilder.h
)

if (NOT DISABLED_LEGACY_ENGINE)
list(APPEND common_training_src
    common/errorcounter.cpp
    common/errorcounter.h
    common/intfeaturedist.cpp
    common/intfeaturedist.h
    common/intfeaturemap.cpp
    common/intfeaturemap.h
    common/mastertrainer.cpp
    common/mastertrainer.h
    common/sampleiterator.cpp
    common/sampleiterator.h
    common/trainingsampleset.cpp
    common/trainingsampleset.h
)
endif()

add_library                 (common_training ${common_training_src})
target_include_directories  (common_training PUBLIC common ${CMAKE_CURRENT_BINARY_DIR})
target_link_libraries       (common_training PUBLIC libtesseract)
generate_export_header      (common_training EXPORT_MACRO_NAME TESS_COMMON_TRAINING_API)
project_group               (common_training "Training Tools")

########################################
# EXECUTABLE ambiguous_words
########################################

if (NOT DISABLED_LEGACY_ENGINE)
add_executable              (ambiguous_words ambiguous_words.cpp)
target_link_libraries       (ambiguous_words common_training)
project_group               (ambiguous_words "Training Tools")
install                     (TARGETS ambiguous_words RUNTIME DESTINATION bin LIBRARY DESTINATION lib ARCHIVE DESTINATION lib)
endif()


########################################
# EXECUTABLE classifier_tester
########################################

if (NOT DISABLED_LEGACY_ENGINE)
add_executable              (classifier_tester classifier_tester.cpp)
target_link_libraries       (classifier_tester common_training)
project_group               (classifier_tester "Training Tools")
install                     (TARGETS classifier_tester RUNTIME DESTINATION bin LIBRARY DESTINATION lib ARCHIVE DESTINATION lib)
endif()


########################################
# EXECUTABLE combine_tessdata
########################################

add_executable              (combine_tessdata combine_tessdata.cpp)
target_link_libraries       (combine_tessdata common_training)
project_group               (combine_tessdata "Training Tools")
install                     (TARGETS combine_tessdata RUNTIME DESTINATION bin LIBRARY DESTINATION lib ARCHIVE DESTINATION lib)


########################################
# EXECUTABLE cntraining
########################################

if (NOT DISABLED_LEGACY_ENGINE)
add_executable              (cntraining cntraining.cpp)
target_link_libraries       (cntraining common_training)
project_group               (cntraining "Training Tools")
install                     (TARGETS cntraining RUNTIME DESTINATION bin LIBRARY DESTINATION lib ARCHIVE DESTINATION lib)
endif()


########################################
# EXECUTABLE dawg2wordlist
########################################

add_executable              (dawg2wordlist dawg2wordlist.cpp)
target_link_libraries       (dawg2wordlist common_training)
project_group               (dawg2wordlist "Training Tools")
install                     (TARGETS dawg2wordlist RUNTIME DESTINATION bin LIBRARY DESTINATION lib ARCHIVE DESTINATION lib)


########################################
# EXECUTABLE mftraining
########################################

if (NOT DISABLED_LEGACY_ENGINE)
add_executable              (mftraining mftraining.cpp mergenf.cpp mergenf.h)
target_link_libraries       (mftraining common_training)
project_group               (mftraining "Training Tools")
install                     (TARGETS mftraining RUNTIME DESTINATION bin LIBRARY DESTINATION lib ARCHIVE DESTINATION lib)
endif()


########################################
# EXECUTABLE shapeclustering
########################################

if (NOT DISABLED_LEGACY_ENGINE)
add_executable              (shapeclustering shapeclustering.cpp)
target_link_libraries       (shapeclustering common_training)
project_group               (shapeclustering "Training Tools")
install                     (TARGETS shapeclustering RUNTIME DESTINATION bin LIBRARY DESTINATION lib ARCHIVE DESTINATION lib)
endif()


########################################
# EXECUTABLE wordlist2dawg
########################################

add_executable              (wordlist2dawg wordlist2dawg.cpp)
target_link_libraries       (wordlist2dawg common_training)
project_group               (wordlist2dawg "Training Tools")
install                     (TARGETS wordlist2dawg RUNTIME DESTINATION bin LIBRARY DESTINATION lib ARCHIVE DESTINATION lib)


if (ICU_FOUND)

if (NOT SW_BUILD)
    include_directories(${ICU_INCLUDE_DIRS})
endif()

########################################
# LIBRARY unicharset_training
########################################

file(GLOB unicharset_training_src
    unicharset/*
)

add_library                 (unicharset_training ${unicharset_training_src})
if (SW_BUILD)
target_link_libraries       (unicharset_training PUBLIC common_training org.sw.demo.unicode.icu.i18n)
else()
target_link_libraries       (unicharset_training PUBLIC common_training ${ICU_LINK_LIBRARIES})
endif()
target_include_directories  (unicharset_training PUBLIC unicharset ${CMAKE_CURRENT_BINARY_DIR})
generate_export_header      (unicharset_training EXPORT_MACRO_NAME TESS_UNICHARSET_TRAINING_API)
project_group               (unicharset_training "Training Tools")


########################################
# EXECUTABLE combine_lang_model
########################################

add_executable              (combine_lang_model combine_lang_model.cpp)
target_link_libraries       (combine_lang_model unicharset_training)
project_group               (combine_lang_model "Training Tools")
install                     (TARGETS combine_lang_model RUNTIME DESTINATION bin LIBRARY DESTINATION lib ARCHIVE DESTINATION lib)


########################################
# EXECUTABLE lstmeval
########################################

add_executable              (lstmeval lstmeval.cpp)
target_link_libraries       (lstmeval unicharset_training ${LIB_pthread})
project_group               (lstmeval "Training Tools")
install                     (TARGETS lstmeval RUNTIME DESTINATION bin LIBRARY DESTINATION lib ARCHIVE DESTINATION lib)


########################################
# EXECUTABLE lstmtraining
########################################

add_executable              (lstmtraining lstmtraining.cpp)
target_link_libraries       (lstmtraining unicharset_training ${LIB_pthread})
project_group               (lstmtraining "Training Tools")
install                     (TARGETS lstmtraining RUNTIME DESTINATION bin LIBRARY DESTINATION lib ARCHIVE DESTINATION lib)


########################################
# EXECUTABLE merge_unicharsets
########################################

add_executable              (merge_unicharsets merge_unicharsets.cpp)
target_link_libraries       (merge_unicharsets common_training)
project_group               (merge_unicharsets "Training Tools")
install                     (TARGETS merge_unicharsets RUNTIME DESTINATION bin LIBRARY DESTINATION lib ARCHIVE DESTINATION lib)


########################################
# EXECUTABLE set_unicharset_properties
########################################

add_executable              (set_unicharset_properties set_unicharset_properties.cpp)
target_link_libraries       (set_unicharset_properties unicharset_training)
project_group               (set_unicharset_properties "Training Tools")
install                     (TARGETS set_unicharset_properties RUNTIME DESTINATION bin LIBRARY DESTINATION lib ARCHIVE DESTINATION lib)


########################################
# EXECUTABLE unicharset_extractor
########################################

add_executable              (unicharset_extractor unicharset_extractor.cpp)
target_link_libraries       (unicharset_extractor unicharset_training)
project_group               (unicharset_extractor "Training Tools")
install                     (TARGETS unicharset_extractor RUNTIME DESTINATION bin LIBRARY DESTINATION lib ARCHIVE DESTINATION lib)


########################################

if (NOT SW_BUILD)
    find_package(PkgConfig)
endif()

if (PKG_CONFIG_FOUND OR SW_BUILD)

if (PKG_CONFIG_FOUND)
pkg_check_modules(Pango REQUIRED pango>=1.22.0)
pkg_check_modules(Cairo REQUIRED cairo)
pkg_check_modules(PangoFt2 REQUIRED pangoft2)
pkg_check_modules(PangoCairo REQUIRED pangocairo)
pkg_check_modules(FontConfig REQUIRED fontconfig)
endif()


########################################
# LIBRARY pango_training
########################################

file(GLOB pango_training_src
    pango/*
)

add_library                 (pango_training ${pango_training_src})
target_link_libraries       (pango_training PUBLIC unicharset_training)
if (SW_BUILD)
target_link_libraries       (pango_training PUBLIC org.sw.demo.gnome.pango.pangocairo)
else()
if (PKG_CONFIG_FOUND)
target_include_directories  (pango_training BEFORE PUBLIC ${Cairo_INCLUDE_DIRS} ${Pango_INCLUDE_DIRS})
target_compile_definitions  (pango_training PUBLIC -DPANGO_ENABLE_ENGINE)
target_link_libraries       (pango_training PUBLIC
    ${Pango_LINK_LIBRARIES}
    ${Cairo_LINK_LIBRARIES}
    ${PangoCairo_LINK_LIBRARIES}
    ${PangoFt2_LINK_LIBRARIES}
    ${FontConfig_LINK_LIBRARIES}
)
endif()
endif()
target_include_directories  (pango_training PUBLIC pango ${CMAKE_CURRENT_BINARY_DIR})
generate_export_header      (pango_training EXPORT_MACRO_NAME TESS_PANGO_TRAINING_API)
project_group               (pango_training "Training Tools")


########################################
# EXECUTABLE text2image
########################################

set(text2image_src
    text2image.cpp
    degradeimage.cpp
    degradeimage.h
)

add_executable              (text2image ${text2image_src})
target_link_libraries       (text2image pango_training)
project_group               (text2image "Training Tools")
install                     (TARGETS text2image RUNTIME DESTINATION bin LIBRARY DESTINATION lib ARCHIVE DESTINATION lib)

endif()
endif(ICU_FOUND)

###############################################################################

=== debian/changelog ===
ghostscript (9.55.0~dfsg1-0ubuntu5) jammy; urgency=medium

  * No-change rebuild for ppc64el baseline bump.

 -- Łukasz 'sil2100' Zemczak <lukasz.zemczak@ubuntu.com>  Wed, 23 Mar 2022 14:54:34 +0100

ghostscript (9.55.0~dfsg1-0ubuntu4) jammy; urgency=medium

  * Just mark all libtesseract symbols optional and be done with it.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 07 Dec 2021 21:21:02 +0000

ghostscript (9.55.0~dfsg1-0ubuntu3) jammy; urgency=medium

  * Mark as optional various symbols which are leaked from the embedded
    tesseract library and are not part of the public API, and which are also
    arch-specific so causing build failures on non-x86.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 07 Dec 2021 20:27:02 +0000

ghostscript (9.55.0~dfsg1-0ubuntu2) jammy; urgency=medium

  * Merge with Debian unstable. Remaining changes:
    - New re-packaging of Ghostscript 9.54.0, keeping the leptonica and
      tesseract convenience copies in as they are not in Ubuntu Main. Added
      appropriate remark to debian/copyright.
    - Updated debian/libgs9.symbols.

 -- Paride Legovini <paride@ubuntu.com>  Thu, 02 Dec 2021 12:39:37 +0100

ghostscript (9.55.0~dfsg-3) unstable; urgency=medium

  * add patch cherry-picked upstream
    to fix the logic for freeing X pixmap;
    really closes: bug#998888, thanks again to Florian Lindemann

 -- Jonas Smedegaard <dr@jones.dk>  Tue, 30 Nov 2021 15:46:45 +0100

ghostscript (9.55.0~dfsg-2) unstable; urgency=medium

  * add patch cherry-picked upstream
    to fix gx_default_copy_alpha calling get_bits_rectangle;
    closes: bug#1000710, thanks to Hilmar Preuße

 -- Jonas Smedegaard <dr@jones.dk>  Mon, 29 Nov 2021 11:07:05 +0100

ghostscript (9.55.0~dfsg1-0ubuntu1) jammy; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - New re-packaging of Ghostscript 9.54.0, keeping the leptonica and
      tesseract convenience copies in as they are not in Ubuntu Main. Added
      appropriate remark to debian/copyright.
  * Updated debian/libgs9.symbols.

 -- Till Kamppeter <till.kamppeter@gmail.com>  Mon, 22 Nov 2021 18:24:56 +0100

ghostscript (9.55.0~dfsg-1) unstable; urgency=medium

  [ upstream ]
  * new release

  [ Jonas Smedegaard ]
  * drop patch cherry-picked upstream now applied;
    unfuzz patch 2009
  * update copyright info:
    + update coverage
    + tighten lintian overrides
  * update symbols:
    + 466 private symbols added
    + 76 private symbols dropped
  * add patches cherry-picked upstream:
    + avoid freeing the background pixmap created by gv;
      closes: bug#704709, thanks to Florian Lindemann
    + fix pdfwrite encoding bugs;
      closes: bug#998458, #998461, thanks to Vincent Lefevre

 -- Jonas Smedegaard <dr@jones.dk>  Fri, 19 Nov 2021 17:58:29 +0100

ghostscript (9.55.0~~rc1~dfsg-1) experimental; urgency=medium

  [ upstream ]
  * new pre-release

  [ Jonas Smedegaard ]
  * drop patches cherry-picked upstream now applied
  * unfuzz patches
  * update copyright info: update coverage
  * add patch 1002 proposed upstream to fix build with gpdf
  * add patch 1003 to fix failure to link against lcms2

 -- Jonas Smedegaard <dr@jones.dk>  Sat, 18 Sep 2021 14:31:04 +0200

ghostscript (9.54.0~dfsg-5) unstable; urgency=medium

  * Revert to not mark /usr/share/ghostscript/* as not-installed:
    works but a clumsy approach
  * properly fix tracking installed files
    by expanding upstream ABI  in debhelper snippets
    (passing ABI-specific path dh_install options confuses dh_missing);
    thanks to Roderich Schupp (see bug#994270)
  * update symbols:
    + 20 private symbols added
    + 1 private symbol dropped

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 15 Sep 2021 14:04:05 +0200

ghostscript (9.54.0~dfsg-4) experimental; urgency=medium

  * mark /usr/share/ghostscript/* as not-installed,
    which is clearly bogus but seems the only (simple) way
    to ignore only for arch-dependent builds;
    closes: bug#994270, thanks to Adrian Bunk

 -- Jonas Smedegaard <dr@jones.dk>  Tue, 14 Sep 2021 23:55:30 +0200

ghostscript (9.54.0~dfsg-3) experimental; urgency=medium

  * update copyright info:
    + use Reference field (not License-Reference);
      tighten lintian overrides
    + update coverage
  * build with pkgkde-symbolshelper;
    build-depend on pkg-kde-tools

 -- Jonas Smedegaard <dr@jones.dk>  Tue, 14 Sep 2021 14:55:10 +0200

ghostscript (9.54.0~dfsg-2) experimental; urgency=medium

  * copyright-check: improve progress messages
  * Merge 9.53.3~dfsg-8:
    + add patch cherry-picked upstream
      to fix access validationaccess validation;
      closes: bug#994011;
      CVE-2021-3781
  * declare compliance with Debian Policy 4.6.0

 -- Jonas Smedegaard <dr@jones.dk>  Thu, 09 Sep 2021 20:41:03 +0200

ghostscript (9.53.3~dfsg-8) unstable; urgency=high

  * add patch cherry-picked upstream
    to fix access validationaccess validation;
    closes: bug#994011;
    CVE-2021-3781
  * Set urgency=high due to security fix.

 -- Jonas Smedegaard <dr@jones.dk>  Thu, 09 Sep 2021 20:12:26 +0200

=== debian/control ===
Source: ghostscript
Section: text
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Printing Team <debian-printing@lists.debian.org>
Uploaders:
 Jonas Smedegaard <dr@jones.dk>,
Build-Depends:
 debhelper-compat (= 13),
 dh-linktree,
 fonts-urw-base35,
 freeglut3-dev,
 libcups2-dev [!kfreebsd-any],
 libcupsimage2-dev [!kfreebsd-any],
 libexpat-dev,
 libfontconfig1-dev,
 libfreetype-dev,
 libice-dev,
 libidn11-dev,
 libijs-dev,
 libjbig2dec0-dev (>= 0.19),
 libjpeg-dev,
 liblcms2-dev,
 libopenjp2-7-dev,
 libpaper-dev,
 libpng-dev,
 libsm-dev,
 libtiff-dev,
 libx11-dev,
 libxext-dev,
 libxt-dev,
 pkg-config,
 pkg-kde-tools,
 rename,
 zlib1g-dev:native,
Standards-Version: 4.6.0
Homepage: https://www.ghostscript.com/
Vcs-Git: https://salsa.debian.org/printing-team/ghostscript.git
Vcs-Browser: https://salsa.debian.org/printing-team/ghostscript
Rules-Requires-Root: no

Package: ghostscript
Architecture: any
Multi-Arch: foreign
Depends:
 libgs9 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 ghostscript-x,
Provides:
 postscript-viewer,
Description: interpreter for the PostScript language and for PDF
 GPL Ghostscript is used for PostScript/PDF preview and printing.
 Usually as a back-end to a program such as ghostview, it can display
 PostScript and PDF documents in an X11 environment.
 .
 Furthermore, it can render PostScript and PDF files as graphics to be
 printed on non-PostScript printers. Supported printers include common
 dot-matrix, inkjet and laser models.

Package: ghostscript-x
Architecture: any
Depends:
 ghostscript (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: interpreter for the PostScript language and for PDF - X11 support
 GPL Ghostscript is used for PostScript/PDF preview and printing.
 Usually as a back-end to a program such as ghostview, it can display
 PostScript and PDF documents in an X11 environment.
 .
 This package contains the GPL Ghostscript output device for X11.

Package: ghostscript-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends:
 libjs-jquery,
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 ghostscript,
Description: interpreter for the PostScript language and for PDF - Documentation
 GPL Ghostscript is used for PostScript/PDF preview and printing.
 Usually as a back-end to a program such as ghostview, it can display
 PostScript and PDF documents in an X11 environment.
 .
 This package contains documentation for GPL Ghostscript, mainly
 targeted developers and advanced users.

Package: libgs9
Section: libs
Architecture: any
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 libgs9-common (= ${source:Version}),
 poppler-data,
 ${misc:Depends},
 ${shlibs:Depends},
Multi-Arch: same
Description: interpreter for the PostScript language and for PDF - Library
 GPL Ghostscript is used for PostScript/PDF preview and printing.
 Usually as a back-end to a program such as ghostview, it can display
 PostScript and PDF documents in an X11 environment.
 .
 This package provides the Ghostscript library which makes the
 facilities of GPL Ghostscript available to applications.

Package: libgs9-common
Section: libs
Architecture: all
Depends:
 ${misc:Depends},
Recommends:
 fonts-droid-fallback,
Multi-Arch: foreign
Description: interpreter for the PostScript language and for PDF - common files
 GPL Ghostscript is used for PostScript/PDF preview and printing.
 Usually as a back-end to a program such as ghostview, it can display
 PostScript and PDF documents in an X11 environment.
 .
 This package provides common architecture-independent files needed by
 the GPL Ghostscript library.
 .
 By default, GPL Ghostscript uses a font from the fonts-droid package to
 approximate glyphs in PDFs for which the requested CJK TrueType font
 is missing.  If the fonts-droid package is not installed, these glyphs
 will be rendered as bullets.

Package: libgs-dev
Section: libdevel
Architecture: any
Depends:
 libgs9 (= ${binary:Version}),
 ${misc:Depends},
Multi-Arch: same
Description: interpreter for the PostScript language and for PDF - Development Files
 GPL Ghostscript is used for PostScript/PDF preview and printing.
 Usually as a back-end to a program such as ghostview, it can display
 PostScript and PDF documents in an X11 environment.
 .
 This package provides the development files for the GPL Ghostscript
 library which makes the facilities of GPL Ghostscript available to
 applications.

## ghostscript 9.56.1~dfsg1

=== debian/changelog ===
ghostscript (9.56.1~dfsg1-0ubuntu3) kinetic; urgency=low

  * Added upstream patch (commit 387f094) for the CUPS/PWG/Apple Raster
    output device not to match custom page sizes against the sizes defined
    in the PPD file, to avoid unwished rotations or size adjustments.
    (cups-filters upstream issue #484).

 -- Till Kamppeter <till.kamppeter@gmail.com>  Sun, 25 Sep 2022 10:26:00 +0200

ghostscript (9.56.1~dfsg1-0ubuntu2) kinetic; urgency=low

  * Added upstream patch (commit 2a54c67) to use stable memory for
    pdfi streams, to avoid double-free when "runpdfend" when done
    with a PDF interpreter started with "runpdfbegin". This caused the
    autopkgtest of xfig to fail (Upstream bugs #705855, #705836, #705210).

 -- Till Kamppeter <till.kamppeter@gmail.com>  Thu, 08 Sep 2022 13:00:00 +0200

ghostscript (9.56.1~dfsg1-0ubuntu1) kinetic; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - New re-packaging of Ghostscript 9.56.1, keeping the leptonica and
      tesseract convenience copies in as they are not in Ubuntu Main. Added
      appropriate remark to debian/copyright.
    - Just mark all libtesseract symbols optional and be done with it.
      They are also arch-specific so causing build failures on non-x86.
  * Added upstream patch (commit 1f876cf) to have Ghostscript's
    "cups"/"pwgraster"/"appleraster"/"urf" output devices support working
    fully PPD-less, allowing to supply all parameters by command line. This
    makes the transition to cups-filters 2.x in Ubuntu 23.04 easier.
  * Updated debian/libgs9.symbols.

 -- Till Kamppeter <till.kamppeter@gmail.com>  Wed, 24 Aug 2022 22:00:00 +0200

ghostscript (9.56.1~dfsg-1) unstable; urgency=medium

  [ upstream ]
  * new release
    + fix text rendering mode 3 and pdfwrite;
      closes: bug#1009680, thanks to Paul Gevers and others

  [ Jonas Smedegaard ]
  * fix watch file
  * update symbols: 1 private symbol added

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 20 Apr 2022 22:47:35 +0200

ghostscript (9.56.0~dfsg-1) unstable; urgency=medium

  [ upstream ]
  * new release

  [ Jonas Smedegaard ]
  * drop superfluous lintian overrides
  * New upstream version 9.56.0~dfsg
  * update symbols:
    + 56 private symbols added
    + 23 private symbols dropped
  * use semantic newlines in long descriptions

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 30 Mar 2022 11:51:53 +0200

ghostscript (9.56.0~~rc2~dfsg-1) experimental; urgency=medium

  [ upstream ]
  * new pre-release

 -- Jonas Smedegaard <dr@jones.dk>  Mon, 21 Mar 2022 09:09:26 +0100

ghostscript (9.56.0~~rc1~dfsg-1) experimental; urgency=medium

  [ upstream ]
  * new pre-release

  [ Jonas Smedegaard ]
  * update copyright info:
    + add Reference and improve Comment
      for files covered by project-wide terms
    + fix interpret unversioned GPL/LGPL to mean any version
    + use multiple separate License-Grant fields
      (not multiple texts in one field, delimited by [...]
      which is hard to distinguish when parsing by a machine)
    + sort License sections alphabetically
    + fix drop bogus Files section
      (likely due to a false positive in older licensecheck
      flagging the word Adobe as a license grant)
    + fix avoid complex shell globbing in file listings
      (leftover from pre-1.0 file format)
    + update coverage
  * update lintian overrides regarding license shortnames
  * tighten lintian overrides
  * drop patches cherry-picked upstream now applied
  * drop patch 1003 adopted upstream
  * drop patch 2009 obsoleted by upstream changes;
    stop have ghostscript-doc depend on libjs-jquery
  * update and unfuzz patches
  * update Maintainer and Vcs-* fields, and drop Uploaders:
    package now maintained in collaborative debian area of Salsa

 -- Jonas Smedegaard <dr@jones.dk>  Mon, 07 Mar 2022 21:47:41 +0100

=== debian/control ===
Source: ghostscript
Section: text
Priority: optional
Maintainer: Jonas Smedegaard <dr@jones.dk>
Build-Depends:
 debhelper-compat (= 13),
 dh-linktree,
 fonts-urw-base35,
 freeglut3-dev,
 libcups2-dev [!kfreebsd-any],
 libcupsimage2-dev [!kfreebsd-any],
 libexpat-dev,
 libfontconfig1-dev,
 libfreetype-dev,
 libice-dev,
 libidn11-dev,
 libijs-dev,
 libjbig2dec0-dev (>= 0.19),
 libjpeg-dev,
 liblcms2-dev,
 libopenjp2-7-dev,
 libpaper-dev,
 libpng-dev,
 libsm-dev,
 libtiff-dev,
 libx11-dev,
 libxext-dev,
 libxt-dev,
 pkg-config,
 pkg-kde-tools,
 rename,
 zlib1g-dev:native,
Standards-Version: 4.6.0
Homepage: https://www.ghostscript.com/
Vcs-Git: https://salsa.debian.org/debian/ghostscript.git
Vcs-Browser: https://salsa.debian.org/debian/ghostscript
Rules-Requires-Root: no

Package: ghostscript
Architecture: any
Multi-Arch: foreign
Depends:
 libgs9 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 ghostscript-x,
Provides:
 postscript-viewer,
Description: interpreter for the PostScript language and for PDF
 GPL Ghostscript is used for PostScript/PDF preview and printing.
 Usually as a back-end to a program such as ghostview,
 it can display PostScript and PDF documents in an X11 environment.
 .
 Furthermore, it can render PostScript and PDF files as graphics
 to be printed on non-PostScript printers.
 Supported printers include common dot-matrix, inkjet and laser models.

Package: ghostscript-x
Architecture: any
Depends:
 ghostscript (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: interpreter for the PostScript language and for PDF - X11 support
 GPL Ghostscript is used for PostScript/PDF preview and printing.
 Usually as a back-end to a program such as ghostview,
 it can display PostScript and PDF documents in an X11 environment.
 .
 This package contains the GPL Ghostscript output device for X11.

Package: ghostscript-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 ghostscript,
Description: interpreter for the PostScript language and for PDF - Documentation
 GPL Ghostscript is used for PostScript/PDF preview and printing.
 Usually as a back-end to a program such as ghostview,
 it can display PostScript and PDF documents in an X11 environment.
 .
 This package contains documentation for GPL Ghostscript,
 mainly targeted developers and advanced users.

Package: libgs9
Section: libs
Architecture: any
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 libgs9-common (= ${source:Version}),
 poppler-data,
 ${misc:Depends},
 ${shlibs:Depends},
Multi-Arch: same
Description: interpreter for the PostScript language and for PDF - Library
 GPL Ghostscript is used for PostScript/PDF preview and printing.
 Usually as a back-end to a program such as ghostview,
 it can display PostScript and PDF documents in an X11 environment.
 .
 This package provides the Ghostscript library
 which makes the facilities of GPL Ghostscript available
 to applications.

Package: libgs9-common
Section: libs
Architecture: all
Depends:
 ${misc:Depends},
Recommends:
 fonts-droid-fallback,
Multi-Arch: foreign
Description: interpreter for the PostScript language and for PDF - common files
 GPL Ghostscript is used for PostScript/PDF preview and printing.
 Usually as a back-end to a program such as ghostview,
 it can display PostScript and PDF documents in an X11 environment.
 .
 This package provides common architecture-independent files
 needed by the GPL Ghostscript library.
 .
 By default, GPL Ghostscript uses a font from the fonts-droid package
 to approximate glyphs in PDFs
 for which the requested CJK TrueType font is missing.
 If the fonts-droid package is not installed,
 these glyphs will be rendered as bullets.

Package: libgs-dev
Section: libdevel
Architecture: any
Depends:
 libgs9 (= ${binary:Version}),
 ${misc:Depends},
Multi-Arch: same
Description: interpreter for the PostScript language and for PDF - Development Files
 GPL Ghostscript is used for PostScript/PDF preview and printing.
 Usually as a back-end to a program such as ghostview,
 it can display PostScript and PDF documents in an X11 environment.
 .
 This package provides the development files
 for the GPL Ghostscript library
 which makes the facilities of GPL Ghostscript available
 to applications.
